
import {M3u8, m3u8_parseUrl} from './m3u8/parser.js'

var file_list = [];

chrome.webRequest.onBeforeRequest.addListener(
	function(details) {
		if (details.tabId==-1) return true
		let tab_key = 't'+details.tabId
		if (!file_list[tab_key]) {
			file_list[tab_key] = []
		}
		// console.log(details)
		if (details.url.indexOf('.m3u8')>-1 && file_list[tab_key].findIndex((e)=>e.url==details.url)==-1) {
			file_list[tab_key].push({
				'id':file_list[tab_key].length,
				'url':details.url,
				'name':'',
				'status':0,
				'm3u8':null,
				'error_msg':'',
				'urls':[],
				'blob':null
			})
			getFileInfo(tab_key, file_list[tab_key].length-1)
		}
		return true
	},
	{urls: ["<all_urls>"]},
);

chrome.runtime.onMessage.addListener(
	function(request, sender, sendResponse) {
		// console.log(request, file_list[request.data.tabId])
		if (request.msg=='getFileList' && file_list[request.data.tabId]) {
			// console.log(request, file_list[request.data.tabId])
			let d = []
			for (let i in file_list[request.data.tabId]) {
				d[i] = {
					'id':file_list[request.data.tabId][i].id,
					'url':file_list[request.data.tabId][i].url,
					'name':file_list[request.data.tabId][i].name,
					'status':file_list[request.data.tabId][i].status,
					'error_msg':file_list[request.data.tabId][i].error_msg,
					'urls':[]
				}
				for (let j in file_list[request.data.tabId][i].urls) {
					d[i].urls[j] = {
						'url':file_list[request.data.tabId][i].urls[j].url,
						'id':file_list[request.data.tabId][i].urls[j].id,
						'status': file_list[request.data.tabId][i].urls[j].status,
						retry: file_list[request.data.tabId][i].urls[j].retey
					}
				}
			}
			chrome.runtime.sendMessage({
				msg: "rgetFileList", 
				data: d
			});
		} else if (request.msg=='download') {
			file_list[request.data.tabId][request.data.index].status=3
			chrome.tabs.sendMessage(parseInt(request.data.tabId.substr(1)), {
				msg:"download",
				data:{
					tabId:request.data.tabId,
					index:request.data.index,
					file:file_list[request.data.tabId][request.data.index]
				}
			});
			// download(request.data.tabId, request.data.index)
		} else if (request.msg=='save') {
			chrome.tabs.sendMessage(parseInt(request.data.tabId.substr(1)), {
				msg:"save",
				data:{
					tabId:request.data.tabId,
					index:request.data.index,
					file:file_list[request.data.tabId][request.data.index]
				}
			});
		} else if (request.msg=='download_update_status') {
			console.log(request)
			file_list[request.data.tabId][request.data.index] = request.data.file
		}
	}
);

function getFileInfo(tab_key, index)
{
	let url = file_list[tab_key][index].url
	// url = 'https://events-delivery.apple.com/2409nbcxymeynatwojbbrjuhryomtudb/vod_main_BwqDeqJgBbinxjxLXGwWjBLqDYgCgYXY/sdr_avc_540p_2000/prog_index.m3u8'
	// url = 'https://events-delivery.apple.com/2409nbcxymeynatwojbbrjuhryomtudb/m3u8/vod_index-oXZvssLWyjfQDEQuVuCBHPWDywaNEipk.m3u8'
	m3u8_parseUrl(url).then((response)=>{
		console.log(response)
		file_list[tab_key][index].m3u8 = response
		let i = 0
		if (response.Map.URI!='') {
			file_list[tab_key][index].urls.push({
				id: i++,
				url: response.Map.URI,
				status: 0,
				retry:0,
				body:null
			})
		}
		for (let j in response.Segments) {
			file_list[tab_key][index].urls.push({
				id:i++,
				url:response.Segments[j].URI,
				status: 0,
				retry:0,
				body:null
			})
		}
		file_list[tab_key][index].status=2 //get info successfully
	}).catch(error=>{
		console.log(error)
		file_list[tab_key][index].status=1
		file_list[tab_key][index].error_msg = error.message
	})
}