
var detected_video = [];

chrome.runtime.onMessage.addListener(
	function(request, sender, sendResponse) {
		if (request.msg=='rgetFileList') {
			detected_video = request.data
			renderDetected_video()
		} else if (request.msg=='rsave') {
			const link = document.createElement('a');
			let blob = new Blob([request.data.blob]);
			let a = new Uint8Array(request.data.blob)
			link.href = window.URL.createObjectURL(a);
			link.download = cutUrl(request.data.url);
			link.click();
			window.URL.revokeObjectURL(link.href);
		}
	}
);

document.addEventListener('DOMContentLoaded', function() {
	chrome.tabs.query({active: true, currentWindow: true}, function(tabs){
		chrome.runtime.sendMessage({
			msg: "getFileList", 
			data: {tabId:'t'+tabs[0].id}
		});
	});

	setInterval(() => {
		chrome.tabs.query({active: true, currentWindow: true}, function(tabs){
			chrome.runtime.sendMessage({
				msg: "getFileList", 
				data: {tabId:'t'+tabs[0].id}
			});
		});
	}, 3000);
});

function renderDetected_video()
{
	var a = document.getElementById('list')
	let tmp = '';
	if (detected_video.length==0) {
		document.getElementById('list_table').style.display = "none";
		document.getElementById('no_data').style.display = "block";
	} else {
		document.getElementById('list_table').style.display = "block";
		document.getElementById('no_data').style.display = "none";
	}
	for (let i in detected_video){
		let btn_status = '';
		if (detected_video[i].status==0) {
			btn_status = 'Parsing...'
		} else if (detected_video[i].status==1) {
			btn_status = `<i class="bi bi-x-circle-fill" style="color:red"></i> ` + detected_video[i].error_msg
		} else if (detected_video[i].status==2) {
			btn_status = `<a href="#" id="downloadbtn_${i}"><i class="bi bi-play-circle"></i></a>`
		} else if (detected_video[i].status==3) {
			let count = 0;
			for (let j in detected_video[i].urls) {
				if (detected_video[i].urls[j].status==1) {
					count++;
				}
			}
			btn_status = `<div class="progress" role="progressbar" aria-valuenow="${Math.ceil(count/detected_video[i].urls.length*100)}" aria-valuemin="0" aria-valuemax="100">
				<div class="progress-bar progress-bar-striped progress-bar-animated overflow-visible" style="width:${Math.ceil(count/detected_video[i].urls.length*100)}%; color:white; text-align:center;">${count}/${detected_video[i].urls.length}</div>
			</div>`
		} else if (detected_video[i].status==4) {
			btn_status = `<a href="#" id="save_${i}"><i class="bi bi-download"></i></a>`
		}
		tmp += `<tr id="video_${i}"><td>${cutUrl(detected_video[i].url)}<a href="#" id="copyurl_${i}"> <i class="bi bi-copy"></i></a></td><td id="video_act_${i}">${btn_status}</td></tr>`;
	}
	a.innerHTML = tmp

	for (let i in detected_video){
		let btn = document.getElementById(`copyurl_${i}`)
		if (btn) {
			btn.addEventListener('click', function() {
				navigator.clipboard.writeText(detected_video[i].url);
			});
		}
		
		btn = document.getElementById(`downloadbtn_${i}`)
		if (btn) {
			btn.addEventListener('click', function() {
				// var timer = setInterval(() => {
				// 	merge(timer, detected_video[i])
				// }, 1000);
				document.getElementById(`video_act_${i}`).innerHTML = `<div class="spinner-border spinner-border-sm" role="status">
					<span class="visually-hidden">Loading...</span>
				</div>`;
				chrome.tabs.query({active: true, currentWindow: true}, function(tabs){
					chrome.runtime.sendMessage({
						msg: "download", 
						data: {tabId:'t'+tabs[0].id, index:i}
					});
				});
			});
		}

		btn = document.getElementById(`save_${i}`)
		if (btn) {
			btn.addEventListener('click', function() {
				chrome.tabs.query({active: true, currentWindow: true}, function(tabs){
					chrome.runtime.sendMessage({
						msg: "save", 
						data: {tabId:'t'+tabs[0].id, index:i}
					});
				});
			});
		}
		
	}
}

function cutUrl(url)
{
	let a = url.split('/')
	return a[a.length-1]
}